=== csg/share/CMakeLists.txt ===
add_subdirectory(man)
add_subdirectory(xml)
add_subdirectory(scripts/inverse)
add_subdirectory(template)
