=== csg/src/CMakeLists.txt ===
add_subdirectory(libcsg)
add_subdirectory(tools)
add_subdirectory(csg_boltzmann)
add_subdirectory(csgapps)
add_subdirectory(tests)
