=== share/format/CMakeLists.txt ===
find_package(CLANG_FORMAT 11)
if(NOT CLANG_FORMAT_FOUND)
  return()
endif()

file(GLOB_RECURSE FORMAT_SOURCES ${PROJECT_SOURCE_DIR}/*.c ${PROJECT_SOURCE_DIR}/*.h)
add_custom_target(format
  COMMAND ${CLANG_FORMAT_EXECUTABLE} -i -style=file ${FORMAT_SOURCES}
  DEPENDS ${FORMAT_SOURCES})
