=== tools/src/CMakeLists.txt ===
add_subdirectory(libtools)
add_subdirectory(tools)
add_subdirectory(tests)
