=== debian/changelog ===
votca (2025.1-1) unstable; urgency=medium

  * New upstream release. 

 -- Nicholas Breen <nbreen@debian.org>  Tue, 07 Oct 2025 22:10:23 -0700

votca (2025-2) unstable; urgency=medium

  * Upload to unstable.
  * Remove obsolete Breaks/Replaces/Provides, no longer relevant to any
    upgrade.

 -- Nicholas Breen <nbreen@debian.org>  Sat, 09 Aug 2025 13:32:30 -0700
